#include "hmg.ch"
#include "hmg_BoxLetterShow.ch"
#include "hfcl.ch" 
#include "Main_SQlite.Prg"
#include "sql1.prg"
#include "Calendary.prg"
#include "Calendar.prg"
#include "About.prg"
#include "Password.prg"
#include "Newclave.prg"

 Function Main()

*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*

  SET CODEPAGE TO SPANISH 
 
*-------------------------------------*
  REQUEST SDDODBC, SQLMIX
  RDDSETDEFAULT( "SQLMIX" )
*-------------------------------------*
*----------------------------------* 
 /* Muy importante:
    Primero codigo y idioma en Espaol 
    y luego en Ingles , Aqui solo en Espaol */

 /* Very important:
    First code and language in Spanish
    and then in English , Here only in Spanish */
*----------------------------------* 

  REQUEST HB_CODEPAGE_ESWIN     
  HB_SETCODEPAGE("ESWIN")    
 
  REQUEST HB_LANG_ES   
  HB_LANGSELECT("ES")  

*----------------------------------*
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET INTERACTIVECLOSE ON
*-----------------------------------------------------------------*
  Public nCtEfeito    := 0
  Public nCt          := 1
  Public cDescEfeito  := ""
  Public ficher , cFileD
*-----------------------------------------------------------------*
  PUBLIC SixNox 
  PUBLIC aChecbo 
  PuBLIC aGrid := {}
  PuBLIC aTable := {}
  PuBLIC cNewRecNo
  PuBLIC mRecPtr := 0
  PuBLIC mRecCount := 0
  PuBLIC oDB := Nil 
*-----------------------------------------------------------------*
 SET TOOLTIPSTYLE BALLOON
// this follow rows is required ONLY for HMG Minigui compatibility
#ifdef __MINGW32__
   SET TOOLTIPBACKCOLOR { 193, 224, 255 } 
   SET TOOLTIPFORECOLOR { 000, 000, 000 }
#endi

*-----------------------------------------------------------------*

         DEFINE WINDOW Form_10             ;
		AT 0,0                     ;
		WIDTH 1200 HEIGHT 700      ;
		TITLE "Web Design Experts" ;
                ICON 'Logo'                ; 
                NOSIZE TOPMOST NOMINIMIZE NOMAXIMIZE ;                
                MAIN                      ;
		FONT "Arial" SIZE 10 BACKCOLOR { 211,218,236 } ;
                ON INIT RescueZip() ;
                ON INTERACTIVECLOSE {||.F. }

                ON KEY ESCAPE ACTION  FinalProgram()   


*------------------------------------------------------------------*


			  DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 84,84 FONT "Arial" SIZE 9 FLAT BORDER 
                  
				BUTTON Button_1a                        ;
					CAPTION 'Managers'              ;
					PICTURE 'resource\Imagen0.jpg'  ;  
					ACTION MsgInfo('Link fantasy ,Click! 1')

				BUTTON Button_2a                        ;
					CAPTION 'Banks'                 ;
					PICTURE 'resource\Imagen1.jpg'  ;
				        ACTION  MsgInfo('Link fantasy ,Click! 2')

				BUTTON Button_3a                        ;
					CAPTION 'Employees'             ;
					PICTURE 'resource\Imagen2.jpg'  ;
					ACTION Employees() 

                                BUTTON Button_4a                        ;
					CAPTION 'Calculator'            ;
					PICTURE 'resource\Imagen3.jpg'  ;
					ACTION  Calendary()

                                BUTTON Button_5a                        ;
					CAPTION 'Commercial'            ;
					PICTURE 'resource\Imagen4.jpg'  ;
					ACTION MsgInfo('Link fantasy ,Click! 3')

                                BUTTON Button_6a                        ;
					CAPTION 'Purchases'             ;
					PICTURE 'resource\Imagen5.jpg'  ;
					ACTION MsgInfo('Link fantasy ,Click! 4')

                                BUTTON Button_7a                        ;
					CAPTION 'Tools'                 ;
					PICTURE 'resource\Imagen6.jpg'  ;  
					ACTION MsgInfo('Link fantasy ,Click! 5')
                                                         
				BUTTON Button_8a                        ;
					CAPTION 'Exit-About'            ;
					PICTURE 'resource\Exit02.jpg'   ; 
					ACTION FinalProgram()           ;  
					DROPDOWN

					DEFINE DROPDOWN MENU BUTTON Button_8a 
						ITEM 'Exit'   ACTION FinalProgram()  IMAGE 'resource\exitx.Bmp'   
						ITEM 'About'  ACTION About()         IMAGE 'resource\home.Bmp'      
					END MENU

			  END TOOLBAR

    DEFINE IMAGE Fondo_1  
         ROW     100 
         COL     000 
         WIDTH  1280
         HEIGHT  680   
         PICTURE 'resource\tekstura_futurizm_1680x1050_(www.GdeFon.ru).jpg'       
         VISIBLE .T.
         STRETCH .T.
    END IMAGE


*------------------------------------------------------------------------------------------------------------------------*

    LetterShadow (024, 730 ,"01Ahi","02Ahi","Web Design Experts","Wide Latin",20,.T.,.T., 000,000,000 , 255, 128,000)   

    LabelBox( 056, 866, 245, 020 ,"13","Copyright"+SPACE(06)+"All rights reserved","", 9 ,.T.,.T., 100,009,000 ,000,000,100)  

    nCode:=HB_UCODE("") // Devuelve el cdigo (nmero) Unicode del caracter ""    ""+HB_UCHAR(nCode)

    LabelBox( 056, 927, 245, 020 ,"14",HB_UCHAR(nCode)                            ,"", 9 ,.T.,.T., 100,009,000 , 000,000,100)  

    LabelBox( 070, 846, 245, 020 ,"15","mustalopez@gmail.com - Mustafa Lpez"     ,"", 9 ,.T.,.T., 100,009,000 , 000,000,100)   

*------------------------------------------------------------------------------------------------------------------------*

  END WINDOW 

    SETWINDOWCURSOR ( Form_10.ToolBar_1.Handle, "resource\finger.cur")
    SETWINDOWCURSOR ( Form_10.Button_1a.Handle, "resource\finger.cur")

    CENTER WINDOW Form_10
    MAXIMIZE WINDOW Form_10
    ACTIVATE WINDOW Form_10

 return nil


*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

*------------------------------------------------------------------------------*
 Function FinalProgram()
*------------------------------------------------------------------------------*

 IF MsgYesNo("Do you want to finish the program ?","Atention !!!") = .T.
      CreateZip() 
      Form_10.Release
    Return .T.
 EndIf


*------------------------------------------------------------------------------*
Function CreateZip()
*------------------------------------------------------------------------------*

 local aDir:=Directory("*.db3")
 local aDiM:=Directory("*.mem")
 local afiles:={}
 local x , y

        For x:=1 to len(aDir)
	    aadd(afiles,adir[x,1])
	next

        For y:=1 to len(aDiM)
	    aadd(afiles,adiM[y,1])
	next

	COMPRESS afiles ;
		TO 'backup_files\Zip_Seg.Zip' ;
		BLOCK {|| NIL }  ;
                OVERWRITE


  IF File("backup_files\Zip_Seg.Zip")
    md5string := hb_md5file("backup_files\Zip_Seg.Zip")
    x := fcreate("backup_files\Zip_Seg.md5")
    fwrite(x,md5string)
    fclose(x)
  ENDIF 

 Return nil

*------------------------------------------------------------------------------*
Function RescueZip()
*------------------------------------------------------------------------------*

  IF ! FILE('nombre.db3')
       MsgStop("Error,Missing file 'nombre.db3' ","Error Check !!!")
       crearbase("nombre.db3") 
  ENDIF

  IF ! File("backup_files\Zip_Seg.md5")
       msginfo("Error,Missing file 'Zip_Seg.md5' ","Error Check !!!")
    ELSE
     md5string := hb_md5file("backup_files\Zip_Seg.zip")
     x := fopen("backup_files\Zip_Seg.md5")
     md5read := freadstr(x,32)
     fclose(x)
      IF md5read <> md5string
          msginfo("Error,Missing file 'Zip_Seg.zip' or is Altered","Error Check !!!")
          Form_10.Release
          Return nil
      ELSE
          UnPackZip()
      ENDIF
  ENDIF    

 Return nil

*------------------------------------------------------------------------------*
Function UnPackZip()
*------------------------------------------------------------------------------*

  LOCAL filesX:=  "backup_files\Zip_Seg.zip"

       UNCOMPRESS filesX   ;  
               BLOCK {|| NIL } 
            
 Return nil



*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*



