
*------------------------------------ BoxLetterShoW --------------------------*
*------- Idea Orginal Cedida        : Lucho Miranda   ElSalnes@telefonica.net * 
*------- Routine donated by         : Lucho Miranda   ElSalnes@telefonica.net *
*------- Funciones y Areglos        : Mustafa Lpez   mustalopez@gmail.com    * 
*------- Functions and Arrangements : Mustafa Lpez   mustalopez@gmail.com    *
*------- Funciones y Areglos        : Javier Tovar                            * 
*------- Functions and Arrangements : Javier Tovar                            *
*------- http://www.hmgforum.com/viewtopic.php?f=15&t=1389 -------------------*
*-----------------------------------------------------------------------------*

*  Color de Fondo de Window ------->  color crema  {239,235,222}   ( Obcional )  

*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*
*
*                    Summary  Line ,Box , Shadow  2014
*
*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*
/*

            Box              ------------->  Mustafa Lpez
            Line             ------------->  Javier Tovar   
            BoxBox           ------------->  Mustafa Lpez
            BoxShadowL       ------------->  Javier Tovar   
            BoxShadowT       ------------->  Javier Tovar   
            BoxShadow        ------------->  Mustafa Lpez 
            NewBoxShadow     ------------->  Mustafa Lpez
            LetterShadowT    ------------->  Javier Tovar    
            LetterShadow     ------------->  Mustafa Lpez
            LabelBox         ------------->  Mustafa Lpez
            Rectangle        ------------->  Javier Tovar   
            MiFrame          ------------->  Javier Tovar   

                                                                                                           */
*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*

#define YELLOW  { 255,  255,  000 }
#define PINK    { 255,  128,  192 }
#define RED     { 255,  000,  000 }
#define FUCHSIA { 255,  000,  255 }
#define BROWN   { 128,  064,  064 }
#define ORANGE  { 255,  128,  064 }
#define GREEN   { 000,  255,  000 }
#define PURPLE  { 128,  000,  128 }
#define BLACK   { 000,  000,  000 }
#define WHITE   { 255,  255,  255 }
#define GRAY    { 128,  128,  128 }
#define BLUE    { 000,  000,  255 }
#define VERDE   { 000,  128,  000 }


*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*


*----------------------------------------------------------------------------------------------------------*
*                                   Courtesy of Mustafa Lpez                                              *
*----------------------------------------------------------------------------------------------------------*

*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*
Func Box(CurSRow, CurSCol, LastSWidth, LastSHeight , NOSm , SColor01 , SColor02, SColor03 )
*----------------------------------------------------------------------------------------------------------*
*---------------------------------------------------------------------------------------------------------

/*                                   Normal Sintax

       @ 110,120 LABEL Label_01  WIDTH 200 HEIGHT 058 ;
                 FONT "Ms Sans Serif" SIZE 0011 BORDER CLIENTEDGE BACKCOLOR {128,126,255} <----Box

       @ 275,320 LABEL Label_14  WIDTH 250 HEIGHT 003 ;
                 FONT "Ms Sans Serif" SIZE 0011 BORDER CLIENTEDGE BACKCOLOR {255,255,255} <----Line  Horizontal */

*-------------------------------------- New Sintax --------------------------------------------------------*

/*          Sample Parameters Box ------>  ( Caja sin Fondo y Hacer Lineas) (Bottomless Box and Make Lines)

      Row -------->  CurSRow     = 110 
      Col -------->  CurSCol     = 120
      WIDTH ------>  LasSWidth   = 200
      HEIGHT ----->  LastSHeight = 058
      Label name ->  Sclavel01  := ALLTRIM("Label_") + ALLTRIM(NoSm)= Label_01
      SColorx := { SColor01 , SColor02 , SColor03 } ----> BACKCOLOR {128,126,255} 
 
                 Language Syntax Sample   

      Box(110, 120, 200, 058 ,"01", 128,126,255 ) <----------- Box
      Box(275, 320, 250, 003 ,"14", 255,255,255 ) <----------- Line  Horizontal
      Box(200, 480, 001, 400 ,"15", 255,255,255 ) <----------- Line Vertical */

*----------------------------------------------------------------------------------------------------------*

 Local Sclavel01 :=   ALLTRIM("Label_") + ALLTRIM(NoSm) 
 Local SColorx := { SColor01 , SColor02 , SColor03 }  

    DEFINE label &Sclavel01       
         ROW    CurSRow
         COL    CurSCol  
         WIDTH  LastSWidth 
         HEIGHT LastSHeight 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         FONTBOLD .F.
         FONTITALIC .F.
         VISIBLE  .T.  
         BACKCOLOR SColorx 
         FONTCOLOR Nil
         BORDER .T. 
         CLIENTEDGE .T. 
    END LABEL

Return

*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*


*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*
*                                   Courtesy of Javier Tovar                                               *
*----------------------------------------------------------------------------------------------------------*
 FUNC Line(nRow,nCol,nWidth,nHeight,cControl,Color)	
*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*

 /*                     Language Syntax Sample   

          Line( 225, 050, 175, 001 ,"05",  WHITE )    //<----------- Line  Horizontal                   
          Line( 225, 225, 001, 175 ,"06",  RED )      //<----------- Line  Vertical 


          Line(450, 390, 250, 001 ,"06",  WHITE )    //<----------- Line  Horizontal       
          Line(000, 480, 001, 300 ,"07w",  {007 ,002 , 204} )   //BLUE  <----------- Line  Vertical */

*----------------------------------------------------------------------------------------------------------*

  Local clavel01 :=   ALLTRIM("Label_") + ALLTRIM(cControl)

    DEFINE label &clavel01   
         ROW   nRow
         COL   nCol
         WIDTH  nWidth 
         HEIGHT nHeight 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  .T.  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR Color  
         FONTCOLOR Nil
         BORDER .F. 
         CLIENTEDGE .F. 
    END LABEL

RETURN NIL	


*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*


*----------------------------------------------------------------------------------------------------------*
*                                   Courtesy of Mustafa Lpez                                              *
*----------------------------------------------------------------------------------------------------------*

*----------------------------------------------------------------------------------------------------------*
Func   BoxBox( CurSRowx, CurSColx, LastSWidthx, LastSHeightx , Lab ,  Entexe ,Color01Z , Color02Z, Color03Z )
*----------------------------------------------------------------------------------------------------------*

/*                            Normal Sintax                               */
*-----------------------------  Box Raya ------------------------------------------------------------------*
 /*   @ 016,015 LABEL Label_BOX_IN00 WIDTH 545 HEIGHT 355 ;
             FONT "Ms Sans Serif" SIZE 0011 BOLD ITALIC BORDER  

             Form_1.Label_BOX_IN00.Enabled := .F.                         */
*----------------------------------------------------------------------------------------------------------*
*------------------------------ Box Undido-----------------------------------------------------------------*
  
 /* @ 074,033 LABEL Label_BOX_IN01 WIDTH 175 HEIGHT 255 ;
            FONT "Ms Sans Serif" SIZE 0011 BORDER CLIENTEDGE         
              
              Form_1.Label_BOX_IN01.Enabled := .F.                        */
*----------------------------------------------------------------------------------------------------------*

*------------------------- New Sintax ---------------------------------------------------------------------*

 /*          Sample Syntax Parameters BoxBox  -----> ( Cuadro Normal y Hundido ) ( Box Normal and Sunk)  

  Row -------->  CurZRowx         = 016
  Col -------->  CurZColx         = 015
  WIDTH ------>  LasZWidthx       = 545
  HEIGHT ----->  LasZHeightx      = 355
  Label name ->  LclaveZ02        := ALLTRIM("Label_") + ALLTRIM(Lab) = Label_BOX_IN00
  Entexe  ---->  .F. OR .T.     
  ColorxZ := { Color01Z , Color02Z , Color03Z } ---> BACKCOLOR {128,126,255}                   */   

*----------------------------------------------------------------------------------------------------------* 

  /*                    Language Sample  

         BoxBox( 016 , 015 , 545 , 355 , "BOX_IN00",.F., 128 ,126 , 255  )       // <------  Box Raya  -----> BOLD ITALIC BORDER    

                    Form_1.Label_BOX_IN00.Enabled := .F.                                        */
*----------------------------------------------------------------------------------------------------------*

  /*   BoxBox( 074 , 033 , 175 , 255 , "BOX_IN01",.T., 128 ,126 , 255  )   // <-----   Box Undido ----> BORDER CLIENTEDGE     


                    Form_1.Label_BOX_IN01.Enabled := .F.                                         */

*----------------------------------------------------------------------------------------------------------*

 Local Sclavel02 :=   ALLTRIM("Label_") + ALLTRIM(Lab) 
 Local ENTEDGE   :=   Entexe  
 Local ColorxZ   := { Color01Z , Color02Z , Color03Z }  


    DEFINE label &Sclavel02       
         ROW   CurSRowx
         COL   CurSColx  
         WIDTH  LastSWidthx 
         HEIGHT LastSHeightx 
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         FONTBOLD .T.
         FONTITALIC .T.          
         BORDER .T.
         CLIENTEDGE ENTEDGE       //  <---------  .F. OR .T.   
         BACKCOLOR ColorXZ    
    END LABEL
 
Return

*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*

*----------------------------------------------------------------------------------------------------------*
*                                   Courtesy of Javier Tovar                                               *
*----------------------------------------------------------------------------------------------------------*

*----------------------------------------------------------------------------------------------------------*
Func BoxShadowL(CurRowN, CurColN, Nomb, cTexto, nSize, Color1, Color2) 
*----------------------------------------------------------------------------------------------------------*
/*                     Language Syntax Sample   

          BoxShadowL(100, 50, "02" , " Hola, como estas? ", 10, GREEN , BLACK ) */


  Local clavel01N := ALLTRIM("Label_") + ALLTRIM(Nomb)
  Local clavel03N := ALLTRIM("Label_") + ALLTRIM(Nomb)+"a"

  DEFINE label &clavel03N        
         ROW   CurRowN
         COL   CurColN  
         VALUE cTexto
         FONTNAME "Ms Sans Serif"
         FONTSIZE nSize
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  .T.  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .T.
         BACKCOLOR Color2
         FONTCOLOR Color2
    END LABEL
   
    DEFINE label &clavel01N   
         ROW    CurRowN  - 6
         COL    CurColN  - 4
         VALUE cTexto
         FONTNAME "ARIAL"
         FONTSIZE nSize
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  .T.  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .T.
         BACKCOLOR Color1  
         FONTCOLOR Color2
         BORDER .F. 
         CLIENTEDGE .F. 
    END LABEL

Return

*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*


*----------------------------------------------------------------------------------------------------------*
*                                   Courtesy of Javier Tovar                                               *
*----------------------------------------------------------------------------------------------------------*


*----------------------------------------------------------------------------------------------------------*
Func BoxShadowT(CurSRow, CurSCol, LastSWidth, LastSHeight , NOSm , ColorBox, ColorShadow , nType ) 
*----------------------------------------------------------------------------------------------------------*
/*                     Language Syntax Sample   

       BoxShadowT( 020, 600, 175, 058 ,"24", BLUE,      , 1 ) 
       BoxShadowT( 230, 800, 175, 058 ,"31", BLUE,BLACK , 4 )  */

*----------------------------------------------------------------------------------------------------------*

  Local Sclavel01 :=   ALLTRIM("Label_") + ALLTRIM(NoSm) 
  Local Sclavel02 :=   ALLTRIM("Label_") + ALLTRIM(NoSm)+ "a" 

  DO CASE
	CASE nType = 1
		lBorder 	:= .F. 
		lCLIENTEDGE := .F.
	CASE nType = 2
		lBorder 	:= .T. 
		lCLIENTEDGE := .F.	
	CASE nType = 3
		lBorder 	:= .F. 
		lCLIENTEDGE := .T.	
	CASE nType = 4
		lBorder 	:= .T. 
		lCLIENTEDGE := .T.	
  ENDCASE

  IF !Empty(ColorShadow)
    DEFINE label &Sclavel02        
         ROW   CurSRow+6
         COL   CurSCol+6  
         WIDTH  LastSWidth 
         HEIGHT LastSHeight 
         BACKCOLOR ColorShadow           
         BORDER .F.
         CLIENTEDGE .F.
    END LABEL	
  ENDIF

    DEFINE label &Sclavel01        
         ROW   CurSRow
         COL   CurSCol  
         WIDTH  LastSWidth 
         HEIGHT LastSHeight 
         BACKCOLOR ColorBox           
         BORDER lBorder
         CLIENTEDGE lCLIENTEDGE
    END LABEL
	
Return


*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*

*----------------------------------------------------------------------------------------------------------*
*                                   Courtesy of Mustafa Lpez                                              *
*----------------------------------------------------------------------------------------------------------*

*----------------------------------------------------------------------------------------------------------*
Func BoxShadow(CurRow, CurCol, LastWidth, LastHeight, Nom, Num , Color01 , Color02, Color03 )
*----------------------------------------------------------------------------------------------------------*
/*                       Normal Sintax
  
         @ 110,120 LABEL Label_01 WIDTH 200 HEIGHT 058 ;
                    FONT "Ms Sans Serif" SIZE 011 BACKCOLOR  {000,000,000}  

          @ 105,115 LABEL Label_02  WIDTH 200 HEIGHT 058 ;
                    FONT "Ms Sans Serif" SIZE 011 BORDER CLIENTEDGE BACKCOLOR  {128,126,255}  */

*------------------------- New Sintax ---------------------------------------------------------------------*

 /*  Sample Syntax Parameters BoxShadow  ---->    (Caja con Fondo y Sombra) (Fund and Shadow Box) 

     Row -------->  CurRow  = 110 
     Col -------->  CurCol  = 120
     WIDTH ------>  LastWidth  = 200
     HEIGHT ----->  LastHeight = 058
     Label name ->  clavel01 := ALLTRIM("Label_") + ALLTRIM(Nom) = Label_01
     Label name ->  clavel02 := ALLTRIM("Label_") + ALLTRIM(Num) = Label_02
     Colorx := { Color01 , Color02 , Color03 } ---> BACKCOLOR {128,126,255} 
 
             Language Sample   

            BoxShadow(110, 120, 200, 058 ,"01" ,"02", 128 ,126 , 255 )                         */

*----------------------------------------------------------------------------------------------------------*

 Local clavel01 := ALLTRIM("Label_") + ALLTRIM(Nom)
 Local clavel02 := ALLTRIM("Label_") + ALLTRIM(Num)
 Local Colorx := { Color01 , Color02 , Color03 }  

  DEFINE label &clavel01        
         ROW   CurRow
         COL   CurCol  
         WIDTH  LastWidth 
         HEIGHT LastHeight 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE .T.
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR {000,000,000}  
         FONTCOLOR Nil
    END LABEL

    DEFINE label &clavel02   
         ROW    CurRow  - 6
         COL    CurCol  - 5
         WIDTH  LastWidth 
         HEIGHT LastHeight 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE .T.
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR ColorX 
         FONTCOLOR Nil
         BORDER .T.
         CLIENTEDGE .T.
    END LABEL

Return

*----------------------------------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------------------------------*
*--------------------------------------------------------  New BoxShadow ----------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------------------------------*


*----------------------------------------------------------------------------------------------------------*
*                                   Courtesy of Mustafa Lpez                                              *
*----------------------------------------------------------------------------------------------------------*




*-----------------------------------------------------------------------------------------------------------------------------------------------------------------------*
Func NewBoxShadow(CurRowN, CurColN, LastWidthN, LastHeightN, NomN, NumN ,NimN , Vispa1, Vispa2 , Vispa3 , Color01N , Color02N, Color03N , Color04N , Color05N, Color06N )
*-----------------------------------------------------------------------------------------------------------------------------------------------------------------------*

/*                      Normal Sintax

         @ 110,120 LABEL Label_01 WIDTH 200 HEIGHT 058 ;
                    FONT "Ms Sans Serif" SIZE 011 BACKCOLOR  {000,000,000}  

         @ 105,115 LABEL Label_02  WIDTH 200 HEIGHT 058 ;
                    FONT "Ms Sans Serif" SIZE 011 BORDER CLIENTEDGE BACKCOLOR  {128,126,255}  

         @ 105,115 LABEL Label_03  WIDTH 200 HEIGHT 058 ;
                   FONT "Ms Sans Serif" SIZE 011 BORDER CLIENTEDGE BACKCOLOR  {255,128,255}  */

*------------------------- New Sintax ---------------------------------------------------------------------*

/*  Sample Syntax Parameters BoxShadow  ---->    (Caja con Fondo y Sombra) (Fund and Shadow Box) 

     Row -------->  CurRowN  = 110 
     Col -------->  CurColN  = 120
     WIDTH ------>  LastWidthN  = 200
     HEIGHT ----->  LastHeightN = 058
     Label name ->  clavel01N := ALLTRIM("Label_") + ALLTRIM(NomN) = Label_01
     Label name ->  clavel02N := ALLTRIM("Label_") + ALLTRIM(NumN) = Label_02
     Label name ->  clavel03N := ALLTRIM("Label_") + ALLTRIM(NimN) = Label_03
     ColorxN := { Color01N , Color02N , Color03N } ---> BACKCOLOR {128,126,255} 
     ColorYN := { Color04N , Color05N , Color06N } ---> BACKCOLOR {255,128,255}                    */
     
*----------------------------------- Language Sample ------------------------------------------------------* 

 /*      NewBoxShadow( 064, 303, 231, 167 ,"01" ,"02 ","03", .T. , .T. , .T. , 255,255,255, 255,128,255) 
         NewBoxShadow( 064, 303, 231, 167 ,"01" ,"02 ","03", .T. , .T. , .F. , 255,255,255, 255,128,255) 
         NewBoxShadow( 064, 303, 231, 167 ,"01" ,"02 ","03", .T. , .F. , .F. , 255,255,255, 255,128,255)   
         NewBoxShadow( 064, 303, 231, 167 ,"01" ,"02 ","03", .F. , .F. , .T. , 255,255,255, 255,128,255)   
         NewBoxShadow( 064, 303, 231, 167 ,"01" ,"02 ","03", .F. , .T. , .F. , 255,255,255, 255,128,255)   */

*----------------------------------------------------------------------------------------------------------*   
*    Muy Importante: Es Obligatorio colocar Enabled := .F. , si est algn
*    control asociado, ejemplo, Botones, MONTHCALENDAR, TEXTBOX etc...
*----------------------------------------------------------------------------------------------------------* 
*    Very Important: Enabled Mandatory place. = F. , If any
*   associated control, such as Buttons, MonthCalendar, TEXTBOX etc ...
*----------------------------------------------------------------------------------------------------------*

*------------------------------------Language Sample -- ---------------------------------------------------*

/*       Form_1.Label_01.Enabled := .F.   //  <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
         Form_1.Label_02.Enabled := .F.   //  <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
         Form_1.Label_03.Enabled := .F.   //  <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write) */
 
*------------------------------------- End Sample ---------------------------------------------------------*   
*----------------------------------------------------------------------------------------------------------*

 Local clavel01N := ALLTRIM("Label_") + ALLTRIM(NomN)
 Local clavel02N := ALLTRIM("Label_") + ALLTRIM(NumN)
 Local clavel03N := ALLTRIM("Label_") + ALLTRIM(NimN)
 Local ColorxN := { Color01N , Color02N , Color03N }  
 Local ColorYN := { Color04N , Color05N , Color06N }   

 Local VispA := Vispa1   // .T. or .F.
 Local VispB := Vispa2   // .T. or .F.
 Local VispC := Vispa3   // .T. or .F.

  DEFINE label &clavel01N        
         ROW   CurRowN
         COL   CurColN  
         WIDTH  LastWidthN 
         HEIGHT LastHeightN 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  VispA   
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR {000,000,000}  
         FONTCOLOR Nil
    END LABEL

    DEFINE label &clavel02N   
         ROW    CurRowN  - 6
         COL    CurColN  - 5
         WIDTH  LastWidthN 
         HEIGHT LastHeightN 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  VispB  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR ColorXN 
         FONTCOLOR Nil
         BORDER .F.  
         CLIENTEDGE .F. 
    END LABEL
    
    DEFINE label &clavel03N   
         ROW    CurRowN  - 6
         COL    CurColN  - 5
         WIDTH  LastWidthN 
         HEIGHT LastHeightN 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  VispC  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR ColorYN   
         FONTCOLOR Nil
         BORDER .F. 
         CLIENTEDGE .F. 
    END LABEL

Return


*----------------------------------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------- End New BoxShadow -------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------------------------------*

 
*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*


*----------------------------------------------------------------------------------------------------------*
*                                   Courtesy of Javier Tovar                                               *
*----------------------------------------------------------------------------------------------------------*


*----------------------------------------------------------------------------------------------------------*
Func LetterShadowT(nRow, nCol,cControl , cValue ,SizeL ,Color ) 	
*----------------------------------------------------------------------------------------------------------*
*----------------------------------- Language Sample ------------------------------------------------------* 

 /*          LetterShadowT(400, 300,"17" , "La Casa de la Abuela" ,10 ,BLUE )                              */

*----------------------------------------------------------------------------------------------------------*

Local Lclavel01 :=   ALLTRIM("Label_") + ALLTRIM(cControl)
Local Lclavel02 :=   ALLTRIM("Label_") + ALLTRIM(cControl)+"a"
LOCAL nSep 	 := 0
 
	IF SizeL < 10
		nSep := .5
	ELSEIF SizeL < 20
		nSep := 1
	ELSEIF SizeL < 30
		nSep := 1
	ELSEIF SizeL < 40
		nSep := 2
	ELSEIF SizeL < 50
		nSep := 2.5
	ELSE 
		nSep := 2.5	
	ENDIF	

	IF SizeL < 50
	  DEFINE label &Lclavel02        
			 ROW   nRow
			 COL   nCol  
			 VALUE cValue
			 FONTNAME "Arial"
			 FONTSIZE SizeL 
			 TOOLTIP ""
			 FONTBOLD .T.
			 FONTITALIC .F.
			 FONTUNDERLINE .F.
			 FONTSTRIKEOUT .F.
			 HELPID Nil
			 VISIBLE .T.
			 TRANSPARENT .T.
			 ACTION Nil
			 AUTOSIZE .T.
			 BACKCOLOR Nil     
			 FONTCOLOR BLACK
		END LABEL	

		DEFINE label &Lclavel01   
			 ROW  nRow  - nSep
			 COL  nCol  - nSep
			 VALUE cValue
			 FONTNAME "Arial"
			 FONTSIZE  SizeL  
			 TOOLTIP ""
			 FONTBOLD .T.
			 FONTITALIC .F.
			 FONTUNDERLINE .F.
			 FONTSTRIKEOUT .F.
			 HELPID Nil
			 VISIBLE .T.
			 TRANSPARENT .T.
			 ACTION Nil
			 AUTOSIZE .T.
			 BACKCOLOR Nil  
			 FONTCOLOR Color       
		END LABEL
	ELSE
		DEFINE label &Lclavel01   
			 ROW  nRow  - nSep
			 COL  nCol  - nSep
			 VALUE cValue
			 FONTNAME "Arial"
			 FONTSIZE  SizeL  
			 TOOLTIP ""
			 FONTBOLD .T.
			 FONTITALIC .F.
			 FONTUNDERLINE .F.
			 FONTSTRIKEOUT .F.
			 HELPID Nil
			 VISIBLE .T.
			 TRANSPARENT .T.
			 ACTION Nil
			 AUTOSIZE .T.
			 BACKCOLOR Nil  
			 FONTCOLOR Color       
		END LABEL
		
	        DEFINE label &Lclavel02        
			 ROW   nRow
			 COL   nCol  
			 VALUE cValue
			 FONTNAME "Arial"
			 FONTSIZE SizeL 
			 TOOLTIP ""
			 FONTBOLD .T.
			 FONTITALIC .F.
			 FONTUNDERLINE .F.
			 FONTSTRIKEOUT .F.
			 HELPID Nil
			 VISIBLE .T.
			 TRANSPARENT .T.
			 ACTION Nil
			 AUTOSIZE .T.
			 BACKCOLOR Nil     
			 FONTCOLOR BLACK
		END LABEL	

	ENDIF	
Return       


*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*

*----------------------------------------------------------------------------------------------------------*
*                                   Courtesy of Mustafa Lpez                                              *
*----------------------------------------------------------------------------------------------------------*


*-----------------------------------------------------------------------------------------------------------------------------------------------*
 Func LetterShadow(CurLRow, CurLCol,NomL, NumL , Valu , FValoR , SizeL ,bOLdxa, iTAlxa, ColorL01 , ColorL02, ColorL03 , ColorL04 , ColorL05, ColorL06 )
*-----------------------------------------------------------------------------------------------------------------------------------------------*

/*                      Normal Sintax 

        @ 118,500 LABEL Label_55 VALUE "Hello World ..." AUTOSIZE ;
                  FONT "Arial" SIZE 25 BOLD ITALIC ;
                  FONTCOLOR BLACK TRANSPARENT
        @ 116,499 LABEL Label_66 VALUE "Hello World ..." AUTOSIZE ;
                  FONT "Arial" SIZE 25 BOLD ITALIC ;
                  FONTCOLOR {206,223,239}  TRANSPARENT                                         */

*------------------------- New Sintax ---------------------------------------------------------------------*

/*           Sample Syntax Parameters LetterShadow  ------->  (Letras con Sombra) (Shaded Letter)

    Row -------->  CurLRow  = 118 
    Col -------->  CurLCol  = 500
    Label name ->  Lclavel01 := ALLTRIM("Label_") + ALLTRIM(NomL) = Label_55
    Label name ->  Lclavel02 := ALLTRIM("Label_") + ALLTRIM(NumL) = Label_66 
    Valu ------->  Valuex    := ALLTRIM(Valu)  -----> Value "Hola Mundo ..." 
    FValoR ----->  Fonte     := ALLTRIM(FValoR) ----> Value "Ms Sans Serif" .OR. Value " " =  "Arial"   
    SizeL  ----->  Sizex     := SizeL  ------------> FONTSIZE 25 
    LColorx := { ColorL01 , ColorL02 , ColoLr03 } --> FONTCOLOR {000,000,000}  <--- Sombra Negra     
    LColory := { ColorL01 , ColorL02 , ColoLr03 } --> FONTCOLOR {206,223,239}                       */ 
 
*----------------------------------------------------------------------------------------------------------*              
 /*                                     Language Sample  

     LetterShadow (118, 500 ,"55" ,"66","Hello World ...","             ",25,.T.,.T., 000,000,000, 206,223,239 ) -----> Value " " =  "Arial"   


     LetterShadow (118, 500 ,"55" ,"66","Hello World ...","Ms Sans Serif",25,.T.,.T., 000,000,000, 206,223,239 ) */


*-----------------------------------    Language Sample ---------------------------------------------------* 
               
  
/*  LetterShadow( 154, 030 ,"07" ,"08","Mustafa_Lpez"  ,"Snap ITC", 15 ,.T.,.T., 000,000,000, 255,234,000 ) <--- Sombra Negra  y Color

      
    Primero Cordenadas del Texto->  Row 154, Col 030, Nombre del Label = Label_07 , Label = Label_08 , 
    Value = "Mustafa_Lpez" ,  FONT "Arial" FONTSIZE 15 ,.T.,.T.,  y por ultimo el Color ejemplo ---->  000,000,000, 255,234,000  */


*-----------------------------------------------------------------------------------------------------------*

 Local Lclavel01 :=   ALLTRIM("LabelN_") + ALLTRIM(NomL)
 Local Lclavel02 :=   ALLTRIM("LabelN_") + ALLTRIM(NumL)
 Local Valuex    :=   ALLTRIM(Valu)                        
 Local Fonte     :=   ALLTRIM(FValoR)
 Local Sizex     :=   SizeL
 Local FbOLDa    :=   bOLdxa
 Local FiTALICa  :=   iTAlxa
 Local LColorx   :=   { ColorL01 , ColorL02 , ColorL03 }  
 Local LColory   :=   { ColorL04 , ColorL05 , ColorL06 }  

  IF FValoR <= SPACE(1)
     Fonte := "Arial"  
  ENDIF

   DEFINE label &Lclavel01        
         ROW   CurLRow
         COL   CurLCol  
         VALUE valuex
         FONTNAME Fonte               
         FONTSIZE Sizex    
         TOOLTIP ""
         FONTBOLD FbOLDa           //  <---------  .F. OR .T.
         FONTITALIC FiTALICa       //  <---------  .F. OR .T.  
         FONTUNDERLINE .F.            
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE .T.
         TRANSPARENT .T.
         ACTION Nil
         AUTOSIZE .T.
         BACKCOLOR Nil     
         FONTCOLOR LColorX       //BLACK
    END LABEL

    DEFINE label &Lclavel02   
         ROW  CurLRow  - 2
         COL  CurLCol  - 2
         VALUE valuex
         FONTNAME Fonte   
         FONTSIZE  Sizex  
         TOOLTIP ""
         FONTBOLD FbOLDa           //  <---------  .F. OR .T.
         FONTITALIC FiTALICa       //  <---------  .F. OR .T.              
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE .T.
         TRANSPARENT .T.
         ACTION Nil
         AUTOSIZE .T.
         BACKCOLOR Nil  
         FONTCOLOR LColory       
    END LABEL

Return Nil      



*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*


*----------------------------------------------------------------------------------------------------------*
*                                   Courtesy of Mustafa Lpez                                              *
*----------------------------------------------------------------------------------------------------------*


*-----------------------------------------------------------------------------------------------------------------------------------------------*
Func  LabelBox(CurZRow,CurZCol,LasZWidth,LasZHeight,NomZ,ValuZ,FValoRx, SizeZ,bOLdx,iTAlx,ColorZ01,ColorZ02,ColorZ03,ColorZ04,ColorZ05,ColorZ06 )
*------------------------------------------------------------------------------------------------------------------------------------------------*
/*                         Normal Sintax 

       @ 118,040 LABEL Label_55 VALUE 'Hello World'  ;    
                 FONT "Arial" SIZE 23 BOLD ITALIC  BACKCOLOR  {155,197,229}  FONTCOLOR {206,223,239}  ;
                 WIDTH 100 HEIGHT 30 

       @ 382,372 LABEL Label_55 VALUE SUBSTR(DTOC(DATE()),7,4) CENTERALIGN ;
                 FONT "Arial" SIZE 50 BOLD ITALIC BACKCOLOR {000,000,000} FONTCOLOR {255,255,255}   ;
                 WIDTH 200 HEIGHT 90                                                                      */
                                      
*--------------------------------------- New Sintax ---------------------------------------------------------*

/*          Sample Syntax Parameters LabelBox  -----> ( Simplificar el Label Normal) (Simplify Normal Label)  

   Row -------->  CurZRow         = 118 
   Col -------->  CurZCol         = 040
   WIDTH ------>  LasZWidth       = 200
   HEIGHT ----->  LasZHeight      = 058
   Label name ->  LclaveZ01      := ALLTRIM("Label_") + ALLTRIM(NomZ) = Label_55
   ValueZA ---->  ValuZ          := ALLTRIM(ValuZ)  -----> Value "Hola Mundo ..." 
   SizeZA  ---->  SizeZ          := SizeZ ---------------> FONTSIZE 15 
   bOLdx ------>  .F. OR .T.  
   iTAlx ------>  .F. OR .T.  
   LColorZa := { ColorZ01 , ColorZ02 , ColoLZ03 } --> BACKCOLOR {155,197,229} 
   LColorZb := { ColorZ04 , ColorZ05 , ColoLZ06 } --> FONTCOLOR {206,223,239}                             */           
 
*---------------------------    Language Sample -----------------------------------------------------------* 

/*  LabelBox(118, 040, 200, 058 ,"55","Hello World","Ms Sans Serif",15 , 155,197,229 , 206,223,239 ) <---"Hello World.." or ALLTRIM("Hello World..")
    LabelBox(118, 140, 200, 058 ,"55",DTOC(DATE()) ,"Ms Sans Serif",15 , 155,197,229 , 206,223,239 ) <--- DTOC(DATE())
    LabelBox(600, 338, 210, 028 ,"55",             ,""     ,12 ,.T.,.T., 000,000,000 , 255,255,255 ) <----Without Value  <-----Sin Value
    LabelBox(118, 140, 200, 058 ,"55",DTOC(DATE()) ,""     ,15 ,    ,   ,    ,    ,   ,    )         <--- Without Colour <-----Sin Color
    LabelBox(118, 140, 200, 058 ,"55","Hello World","Cooper Black"  ,15 ,.T.,.T.,   ,    ,   ,   ,   ,   ) <--- FONTBOLD .T. FONTITALIC .T. */

*----------------------------------------------------------------------------------------------------------*

 Local LclaveZ01  :=   ALLTRIM("Label_") + ALLTRIM(NomZ)
 Local ValueZA    :=   ValuZ  
 Local Fontex     :=   ALLTRIM(FValoRx)                            
 Local SizeZA     :=   SizeZ
 Local FbOLD      :=   bOLdx
 Local FiTALIC    :=   iTAlx 
 Local LColorZa   := { ColorZ01 , ColorZ02 , ColorZ03 }  
 Local LColorZb   := { ColorZ04 , ColorZ05 , ColorZ06 }  

   IF FValoRx <= SPACE(1)
      Fontex := "Arial"  
    ENDIF
 
                                        *---  SAMPLE ------*
     DEFINE label &LclaveZ01       //  <---------  Label_55   
          ROW   CurZRow            //  <---------  118
          COL   CurZCol            //  <---------  040              
          WIDTH  LasZWidth         //  <---------  200 
          HEIGHT LasZHeight        //  <---------  058  
          VALUE ValueZA            
          FONTNAME Fontex          //"Arial"         
          FONTSIZE SizeZA          //  <---------  15 
          TOOLTIP ""
          ALIGNMENT LEFT            // <--------- ( CENTER,LEFT,RIGHT )( CENTERALIGN ,RIGHTALIGN) 
          FONTBOLD FbOLD           //  <---------  .F. OR .T.
          FONTITALIC FiTALIC       //  <---------  .F. OR .T.              
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.
          TRANSPARENT .T.
          ACTION Nil
          AUTOSIZE .T.
          BACKCOLOR  LColorZa       //  <--------- {155,197,229} 
          FONTCOLOR  LColorZb       //  <--------- {206,223,239}  
    END LABEL

Return
 
*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*

*----------------------------------------------------------------------------------------------------------*
*                                   Courtesy of Javier Tovar                                               *
*----------------------------------------------------------------------------------------------------------*


*----------------------------------------------------------------------------------------------------------*
FUNC Rectangle(nRow,nCol,nWidth,nHeight,cControl,Color,nType,nWidthG,nWidthD)	
*----------------------------------------------------------------------------------------------------------*

/*                            Language Sample 

               Rectangle(50,300,175,50,"12",BLUE,1,5,1)
               Rectangle(50,300,175,50,"12",{ 007,002,204 } ,3,3,2)
               Rectangle(50,300,175,50,"12",{ 007,002,204 } ,1,5,1)                                        */
    
*----------------------------------------------------------------------------------------------------------*

Local clavel01 := ALLTRIM("Label_") + ALLTRIM(cControl)
Local clavel02 := ALLTRIM("Label_") + ALLTRIM(cControl)+ "a"
Local clavel03 := ALLTRIM("Label_") + ALLTRIM(cControl)+ "b" 
Local clavel04 := ALLTRIM("Label_") + ALLTRIM(cControl)+ "c" 

LOCAL CurSRow1		:= nRow
LOCAL CurSCol1 		:= nCol
LOCAL LastSWidth1 	:= 0
LOCAL LastSHeight1 	:= 0

LOCAL CurSRow2		:= nRow
LOCAL CurSCol2 		:= nCol 
LOCAL LastSWidth2  	:= 0
LOCAL LastSHeight2 	:= 0

LOCAL CurSRow3		:= nRow
LOCAL CurSCol3 		:= nCol+nWidth
LOCAL LastSWidth3  	:= 0
LOCAL LastSHeight3 	:= 0

LOCAL CurSRow4		:= nRow+nHeight
LOCAL CurSCol4 		:= nCol 	
LOCAL LastSWidth4  	:= 0
LOCAL LastSHeight4 	:= 0

	DO CASE 
		CASE nType = 1
			LastSWidth1 	:= nWidth
			LastSHeight1 	:= nWidthG
			LastSWidth2  	:= nWidthG
			LastSHeight2 	:= nHeight
			LastSWidth3  	:= nWidthG
			LastSHeight3 	:= nHeight
			LastSWidth4  	:= nWidth + nWidthG
			LastSHeight4 	:= nWidthG	
		CASE nType = 2
			LastSWidth1 	:= nWidth
			LastSHeight1 	:= nWidthD
			LastSWidth2  	:= nWidthG
			LastSHeight2 	:= nHeight
			LastSWidth3  	:= nWidthG
			LastSHeight3 	:= nHeight
			LastSWidth4  	:= nWidth + nWidthG
			LastSHeight4 	:= nWidthD	
		CASE nType = 3
			LastSWidth1 	:= nWidth
			LastSHeight1 	:= nWidthG
			LastSWidth2  	:= nWidthD
			LastSHeight2 	:= nHeight
			LastSWidth3  	:= nWidthD
			LastSHeight3 	:= nHeight
			LastSWidth4  	:= nWidth + nWidthD
			LastSHeight4 	:= nWidthG	
		CASE nType = 4
			LastSWidth1 	:= nWidth
			LastSHeight1 	:= nWidthG
			LastSWidth2  	:= nWidthG
			LastSHeight2 	:= nHeight
			LastSWidth3  	:= nWidthD
			LastSHeight3 	:= nHeight
			LastSWidth4  	:= nWidth + nWidthD
			LastSHeight4 	:= nWidthD
	ENDCASE

    DEFINE label &clavel01   
         ROW   CurSRow1
         COL   CurSCol1  
         WIDTH  LastSWidth1 
         HEIGHT LastSHeight1 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  .T.  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR Color  
         FONTCOLOR Nil
         BORDER .F. 
         CLIENTEDGE .F. 
    END LABEL

    DEFINE label &clavel02 
         ROW   CurSRow2
         COL   CurSCol2  
         WIDTH  LastSWidth2 
         HEIGHT LastSHeight2 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  .T.  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR Color  
         FONTCOLOR Nil
         BORDER .F. 
         CLIENTEDGE .F. 
    END LABEL

    DEFINE label &clavel03  
         ROW   CurSRow3
         COL   CurSCol3  
         WIDTH  LastSWidth3 
         HEIGHT LastSHeight3 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  .T.  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR Color 
         FONTCOLOR Nil
         BORDER .F. 
         CLIENTEDGE .F. 
    END LABEL

    DEFINE label &clavel04 
         ROW   CurSRow4
         COL   CurSCol4  
         WIDTH  LastSWidth4 
         HEIGHT LastSHeight4 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  .T.  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR Color  
         FONTCOLOR Nil
         BORDER .F. 
         CLIENTEDGE .F. 
    END LABEL

RETURN NIL	

*----------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------*


*----------------------------------------------------------------------------------------------------------*
*                                   Courtesy of Javier Tovar                                               *
*----------------------------------------------------------------------------------------------------------*


*----------------------------------------------------------------------------------------------------------*
FUNC MiFrame(nRow,nCol,nWidth,nHeight,cControl,cTexto,Color,ColorBackground)	
*----------------------------------------------------------------------------------------------------------*

 /*             Language Sample 
               
       MiFrame(300,300,175,50,"16","Mi Frame",BLUE,VERDE)  

       MiFrame(300,300,175,50,"16","Mi Frame", {007 ,002 , 204},{ 005, 186, 010 }  )  //BLUE , VERDE)  */


Local clavel01 := ALLTRIM("Label_") + ALLTRIM(cControl)
Local clavel02 := ALLTRIM("Label_") + ALLTRIM(cControl)+ "a"
Local clavel03 := ALLTRIM("Label_") + ALLTRIM(cControl)+ "b" 
Local clavel04 := ALLTRIM("Label_") + ALLTRIM(cControl)+ "c" 
Local clavel05 := ALLTRIM("Label_") + ALLTRIM(cControl)+ "d" 

LOCAL CurSRow1		:= nRow
LOCAL CurSCol1 		:= nCol
LOCAL LastSWidth1 	:= nWidth
LOCAL LastSHeight1 	:= 1

LOCAL CurSRow2		:= nRow
LOCAL CurSCol2 		:= nCol 
LOCAL LastSWidth2  	:= 1
LOCAL LastSHeight2 	:= nHeight

LOCAL CurSRow3		:= nRow
LOCAL CurSCol3 		:= nCol+nWidth
LOCAL LastSWidth3  	:= 1
LOCAL LastSHeight3 	:= nHeight

LOCAL CurSRow4		:= nRow+nHeight
LOCAL CurSCol4 		:= nCol 	
LOCAL LastSWidth4  	:= nWidth + 1
LOCAL LastSHeight4 	:= 1

    DEFINE label &clavel02   
         ROW   CurSRow1
         COL   CurSCol1  
         WIDTH  LastSWidth1 
         HEIGHT LastSHeight1 
         VALUE ""
         FONTNAME "Arial"// "Ms Sans Serif"
         FONTSIZE 09 // 11
         TOOLTIP ""
         FONTBOLD .T. //.F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  .T.  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR Color  
         FONTCOLOR Nil
         BORDER .F. 
         CLIENTEDGE .F. 
    END LABEL

    DEFINE label &clavel03 
         ROW   CurSRow2
         COL   CurSCol2  
         WIDTH  LastSWidth2 
         HEIGHT LastSHeight2 
         VALUE ""
         FONTNAME "Arial"// "Ms Sans Serif"
         FONTSIZE  09 // 11
         TOOLTIP ""
         FONTBOLD  .T. //.F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  .T.  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR Color  
         FONTCOLOR Nil
         BORDER .F. 
         CLIENTEDGE .F. 
    END LABEL

    DEFINE label &clavel04  
         ROW   CurSRow3
         COL   CurSCol3  
         WIDTH  LastSWidth3 
         HEIGHT LastSHeight3 
         VALUE ""
         FONTNAME "Arial"// "Ms Sans Serif"
         FONTSIZE  09 // 11
         TOOLTIP ""
         FONTBOLD  .T. //.F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  .T.  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR Color 
         FONTCOLOR Nil
         BORDER .F. 
         CLIENTEDGE .F. 
    END LABEL

    DEFINE label &clavel05 
         ROW   CurSRow4
         COL   CurSCol4 
         WIDTH  LastSWidth4 
         HEIGHT LastSHeight4 
         VALUE ""
         FONTNAME "Arial"// "Ms Sans Serif"
         FONTSIZE  09 // 11
         TOOLTIP ""
         FONTBOLD  .T. //.F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  .T.  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR Color  
         FONTCOLOR Nil
         BORDER .F. 
         CLIENTEDGE .F. 
    END LABEL
	
    DEFINE label &clavel01   
         ROW   CurSRow1 - 8
         COL   CurSCol1 + 5
         WIDTH  LastSWidth1 
         HEIGHT LastSHeight1 
         VALUE cTexto
         FONTNAME "Arial"// "Ms Sans Serif"
         FONTSIZE  09 // 11
         TOOLTIP ""
         FONTBOLD  .T. //.F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE  .T.  
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .T.
         BACKCOLOR ColorBackground  
         FONTCOLOR Color
         BORDER .F. 
         CLIENTEDGE .F. 
    END LABEL	
	
RETURN NIL	